﻿local button = CreateFrame("CheckButton", "WorldMapFrameShowBossButtons", WorldMapFrame, "OptionsCheckButtonTemplate")
button:SetSize(24, 24)
_G[button:GetName().."Text"]:SetText("Hide Bosses")

local function setAnchor(self)
	self:ClearAllPoints()
	if MapsterQuestObjectivesDropDown then
		--Mapster can show WorldMapShowDigSites without arch (doesn't check profs if you change the map display type)
		self:SetPoint("LEFT", WorldMapTrackQuest, "RIGHT", 230, 0)
	else
		local arch = select(3, GetProfessions())
		if arch then
			WorldMapShowDigSites:SetPoint("RIGHT", WorldMapQuestShowObjectives, "LEFT", -120, 0)
			self:SetPoint("RIGHT", WorldMapShowDigSites, "LEFT", -100 , 0);
		else
			self:SetPoint("RIGHT", WorldMapQuestShowObjectives, "LEFT", -130, 0);
		end
	end
end

local function checkHideShow(self)
	if EJ_GetMapEncounter(1) then
		self:Show()
	else
		self:Hide()
	end
end

button:SetScript("OnShow", checkHideShow)

button:SetScript("OnClick", function(self, button)
	if self:GetChecked() then
		PlaySound("igMainMenuOptionCheckBoxOn")
		HIDE_BOSS_BUTTONS = true
		WorldMapBossButtonFrame:Hide()
	else
		PlaySound("igMainMenuOptionCheckBoxOff")
		HIDE_BOSS_BUTTONS = nil
		WorldMapBossButtonFrame:Show()
	end
end)

button:SetScript("OnEnter", function(self)
	WorldMapTooltip:SetOwner(self, "ANCHOR_LEFT")
	WorldMapTooltip:SetText("If enabled, the Encounter Journal's boss portraits will be hidden.", nil, nil, nil, nil, 1)
end)

button:SetScript("OnLeave", function(self)
	WorldMapTooltip:Hide()
end)

button:SetScript("OnEvent", function(self, event)
	if event == "WORLD_MAP_UPDATE" then
		checkHideShow(self)
	elseif event == "SKILL_LINES_CHANGED" then
		setAnchor(self)
	elseif event == "PLAYER_LOGIN" then
		self:SetChecked(HIDE_BOSS_BUTTONS)
		setAnchor(self)
		if HIDE_BOSS_BUTTONS then
			WorldMapBossButtonFrame:Hide()
		end
	end
end)
button:RegisterEvent("WORLD_MAP_UPDATE")
button:RegisterEvent("SKILL_LINES_CHANGED")
button:RegisterEvent("PLAYER_LOGIN")
